/*
 * Copyright (c) 1994 Malcolm Beattie.
 * You may distribute under the terms of the GNU General Public License,
 * as specified in the README file.
 */

#ifndef lint
static char rcsid2[] = "$Id: tkpProxy.xs,v 1.1 1994/09/28 21:36:31 mbeattie Exp $";
#endif

/* $Log: tkpProxy.xs,v $
# Revision 1.1  1994/09/28  21:36:31  mbeattie
# Initial revision
#
 */

#define route(proxy, id) (Window) (strtol((id), (char **) 0, 16))

typedef Window Proxy__Tk;

static SV *
receive(proxy)
Proxy__Tk proxy;
{
    TkDisplay *dispPtr = ((TkWindow *) mainwin)->dispPtr;
    Tk_TimerToken timeout;
    Bool (*prevRestrictProc)();
    char *prevArg;
    
    proxyreplyflag = 1;
    prevRestrictProc = Tk_RestrictEvents(SendRestrictProc,
					 (char *) dispPtr->commWindow,
					 &prevArg);
    timeout = Tk_CreateTimerHandler(5000, ProxyTimeoutProc, (ClientData) 0);
    /*
     * Go into a restricted event loop waiting for SendEventProc to receive
     * a reply packet. When it does so (or when ProxyTimeoutProc fires)
     * proxyreplyflag is rest.
     */

    while (proxyreplyflag)
	Tk_DoOneEvent(0);
    
    Tk_DeleteTimerHandler(timeout);
    (void) Tk_RestrictEvents(prevRestrictProc, prevArg, &prevArg);
    /*
     * If proxyreplyreplycache is NULL then we timed out waiting for
     * a reply. The receive XSUB that called us will make sure that
     * an undef gets returned instead of the Nullsv.
     */
    return proxyreplycache;
}

MODULE = ProxyTk	PACKAGE = Proxy::Tk

Proxy::Tk
new(class, proxyname)
	char *	class
	char *	proxyname
	CODE:
	TkDisplay *dispPtr = ((TkWindow *) mainwin)->dispPtr;

	if (!dispPtr->commWindow
	    && SendInit(tclinterp, dispPtr) != TCL_OK)
	    croak(tclinterp->result);

	if (!(RETVAL = LookupName(dispPtr, proxyname, 0)))
	    return;
	OUTPUT:
	RETVAL

void
rawtransport(proxy, sv)
	Proxy::Tk	proxy
	SV *		sv
	CODE:
	{
	    TkDisplay *dispPtr = ((TkWindow *) mainwin)->dispPtr;
	    SV *data = sv_2mortal(newSVpv("P", 1));
	    sv_catsv(data, sv);
	    sv_catpvn(data, "", 1);
	    (void) AppendPropCarefully(dispPtr->display, proxy,
					 dispPtr->commProperty, SvPV(data, na),
					 (PendingCommand *) 0);
	}

void
receive(proxy)
	Proxy::Tk	proxy
	CODE:
	ST(0) = receive(proxy);
	if (!ST(0))
	    ST(0) = sv_newmortal();

Proxy::Tk
route(proxy, id)
	Proxy::Tk	proxy
	char *		id

MODULE = ProxyTk	PACKAGE = Proxy

char *
id()
	CODE:
	static char hexid[32];
	TkDisplay *dispPtr = ((TkWindow *) mainwin)->dispPtr;
	(void) sprintf(hexid, "%lx",
		       (unsigned long) Tk_WindowId(dispPtr->commWindow));
	RETVAL = hexid;
	OUTPUT:
	RETVAL
